<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Invoice extends CI_Controller {
    
    public function __construct() {
        parent::__construct();
         if (! $this->session->userdata ( 'user_logged_in' ) && ! $this->session->userdata ( 'user_logged_in' )) {
            redirect ( 'login', 'refresh' );
        }
        $this->load->vars ( array (
                'global' => 'Available to all views',
                'header' => 'common/header',
                'left' => 'common/left',
                'footer' => 'common/footer' 
        ) );

        $this->load->model('User_model');
        $this->load->model('Invoice_model');
        $this->load->model('Setings_model');
    }

    public function index(){
        $data['invoice_list'] = $this->Invoice_model->invoice_list();
        $this->load->view('invoice_list',$data);
    }

    public function newinvoice(){
        $data['invoice_id'] = !empty($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
        if (!empty($data['invoice_id'])) {
            $invoice_details = $this->Invoice_model->get_from_table('sale_invoice','*',array('invoice_no' => $data['invoice_id']));
            $data['invoice_data'] = (array)$invoice_details[0];
            $data['item_details'] = $this->Invoice_model->get_from_table('invoice_item_detail','*',array('sale_invoice_id' => $data['invoice_data']['sale_invoice_id']));
            $data['customer_details'] = $this->User_model->get_user_data($data['invoice_data']['customer_id']);
        } else {
            $data['invoice_id'] = $this->invoice_id();
        }
        $where = array('contact_type' => 1,'status' => 1);
        $data['customer_list'] = $this->User_model->user_list_where($where);
        $this->load->view('invoice_create',$data);
    }

    public function invoice_id(){
        $last_id = $this->Invoice_model->get_from_table('sale_invoice','max(sale_invoice_id) lastId','sale_invoice_id > 0');
        return 'AJ'.sprintf('%06d', ($last_id[0]->lastId+1));
    }

    public function generate_invoice(){
        $form_data = $this->input->post('invoice_basic');
        $sum_amounts = $this->input->post('items_tot');
        $item_data = $this->input->post('items');
        $userState = $this->input->post('userState');
        $status = $this->input->post('status');

        $data['invoice_data'] = array(
                'invoice_no'    => $form_data[1]['value'],
                'customer_id'   => $form_data[0]['value'],
                'order_no'      => $form_data[2]['value'],
                'invoice_date'  => date('Y-m-d',strtotime(str_replace('/', '-', $form_data[3]['value']))),
                'due_date'      => date('Y-m-d',strtotime(str_replace('/', '-', $form_data[4]['value']))),
                'total'         => $sum_amounts['final_total'],
                'sub_total'     => $sum_amounts['sub_total'],
                'cgst_total'    => $sum_amounts['cgst'],
                'sgst_total'    => $sum_amounts['sgst'],
                'igst_total'    => $sum_amounts['igst'],
                'status'        => $status,
                'date_added'    => date('Y-m-d')
            );
        $check_invoice = $this->Invoice_model->get_from_table('sale_invoice','*',array('invoice_no' => $form_data[1]['value']));
        if (count($check_invoice) > 0) {
            $sale_invoice_id =  $check_invoice[0]->sale_invoice_id;
            $this->Invoice_model->update_data('sale_invoice',$data['invoice_data'],array('invoice_no' => $form_data[1]['value'],'sale_invoice_id' => $sale_invoice_id));
        } else {
            $sale_invoice_id = $this->Invoice_model->insert_data('sale_invoice',$data['invoice_data']);    
        }

        if (count($item_data) > 0) {
            foreach ($item_data as $key => $value) {
                $item_details[] = array(
                    'sale_invoice_id' => $sale_invoice_id,
                    'item' => $value['item_name'],
                    'qty' => $value['quantity'],
                    'uom' => $value['uom'],
                    'rate' => $value['unit_price'],
                    'discount' => $value['discount'],
                    'amount' => $value['price'],
                    'cgst' => (($userState == 19) ? ((($value['quantity'] * $value['unit_price']) * 1.5) / 100) : 0),
                    'sgst' => (($userState == 19) ? ((($value['quantity'] * $value['unit_price']) * 1.5) / 100) : 0),
                    'igst' => (($userState != 19) ? ((($value['quantity'] * $value['unit_price']) * 3) / 100) : 0)
                );
            }

            // $data['customer_details'] = $this->User_model->get_user_data($form_data[0]['value']);
            // $data['item_details'] = $item_details;
            if (count($check_invoice) > 0) {
                $sale_invoice_id =  $check_invoice[0]->sale_invoice_id;
                $this->Invoice_model->delete_data('invoice_item_detail',array('sale_invoice_id' => $sale_invoice_id));
            }
            $this->Invoice_model->insert_data_batch('invoice_item_detail',$item_details);
        }

        echo $form_data[1]['value'];
    }

    public function invoice_print($key_invoice){
        $data['setings'] = $this->Setings_model->get_setings();
        $data['invoice_id'] = $key_invoice;
        $invoice_details = $this->Invoice_model->get_from_table('sale_invoice','*',array('invoice_no' => $data['invoice_id']));
        $data['invoice_data'] = (array)$invoice_details[0];
        $data['item_details'] = $this->Invoice_model->get_from_table('invoice_item_detail','*',array('sale_invoice_id' => $data['invoice_data']['sale_invoice_id']));
        $data['customer_details'] = $this->User_model->get_user_data($data['invoice_data']['customer_id']);
        $this->load->view('invoice_print',$data);
    }
}
?>