<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Itemsn extends CI_Controller {
    
    public function __construct() {
        parent::__construct();
         if (! $this->session->userdata ( 'user_logged_in' ) || !company_url($this->session->userdata ('company_slag'))) {
            redirect ( 'login', 'refresh' );
        }
        $this->load->vars ( array (
                'global' => 'Available to all views',
                'header' => 'common/header',
                'left' => 'common/left',
                'footer' => 'common/footer' 
        ) );

        $this->load->model('Item_modeln');
    }

    public function index(){
        $data['item_list'] = $this->Item_modeln->get_items();
        $items_autocomplete = array();
        $items_barcode = array();
        if (count($data['item_list'])>0) {
            foreach ($data['item_list'] as $key => $value) {
                $items_autocomplete[$key] = new stdClass();
                $items_autocomplete[$key]->id = $value->item_id;
                $items_autocomplete[$key]->name = $value->item_name;

                $items_barcode[$value->item_no] = $value;
            }
        }
        $data['items_autocomplete'] = json_encode($items_autocomplete);
        $data['items_barcode'] = json_encode($items_barcode);
        $this->load->view('item_listn',$data);
    }

    public function newitem(){
        $data['item_id'] = !empty($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
        if ($data['item_id'] > 0) {
            $data['item_details'] = $this->Item_modeln->get_item_details($data['item_id']);
        }
        $this->load->view('new_itemn',$data);
    }

    public function add_items(){
        $item_id = $this->input->post('item_id');
        $item_name = $this->input->post('item_name');
        $item_description = $this->input->post('item_description');
        $unit = $this->input->post('unit');
        $rate_purchase = $this->input->post('rate_purchase');
        $hsn_code = $this->input->post('hsn_code');
        $gst_rate = $this->input->post('gst_rate');
        $rate_sale = $this->input->post('rate_sale');

        $item_data = array(
                'item_name' => $item_name,
                'item_description' => $item_description,
                'unit' => $unit,
                'hsn_code' => $hsn_code,
                'rate_sale' => $rate_sale,
                'rate_purchase' => $rate_purchase,
                'gst_rate' => $gst_rate,
                'date_added' => date('Y-m-d'),
                'date_edited' => date('Y-m-d'),
                'status' => 1
            );
        if ($item_id == 0) {
            $item_data['item_no'] = uniqid();
            $this->generate_barcode($item_data['item_no']);
            $this->Item_modeln->insert_data('items_2',$item_data);
        } else {
            $this->Item_modeln->update_data('items_2',$item_data,array('item_id' => $item_id));
        }
        echo 1;
    }

    public function get_item_stock(){
        $item = $this->input->post('item_id');
        $item_stock = $this->Item_modeln->get_stock($item);
        echo !empty($item_stock->stock) ? $item_stock->stock : 0;
    }

    function generate_barcode($item_code){
        // $item_code = '265fgfghp54';
        $this->load->library('zend');
        $this->zend->load('Zend/Barcode');
        // $barcode         = $this->input->post('location');
        $barimage = Zend_Barcode::draw('code128', 'image', array('text' => $item_code), array());
        var_dump($barimage);
        imagejpeg($barimage, 'assets/barcodeImg/'.$item_code.'.jpg', 100);
        return true; 
    }

    function print_barcode($item_id){
        $data['item_details'] = $this->Item_modeln->get_item_details($item_id);
        $this->load->view('barcode_print',$data);
    }

    private function item_no(){
        $pool = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'; 
        return substr(str_shuffle(str_repeat($pool, ceil(8 / strlen($pool)))), 0, 8);
    }

    public function add_stock(){
        $item = $this->input->post('item_id');
        $qty = $this->input->post('quantity');

        if (!empty($item) && !empty($qty)) {
            $item_add = array('item_id' => $item,'qty_sale'=>0,'qty_purchase'=>$qty,'inv_bill_id'=>0,'date_added'=>date('Y-m-d'),'is_note'=>2);
            $this->Item_modeln->insert_data('item_stock_2',$item_add);
        }
        echo 1;
    }

	public function update_stock(){
        $item = $this->input->post('item_id');
        $qty = $this->input->post('quantity');

        if (!empty($item) && !empty($qty)) {
            $item_add = array('item_id' => $item,'qty_sale'=>$qty,'qty_purchase'=>0,'inv_bill_id'=>0,'date_added'=>date('Y-m-d'),'is_note'=>1);
            $this->Item_modeln->insert_data('item_stock_2',$item_add);
        }
        echo 1;
    }
}
?>