<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Purchase extends CI_Controller {
    
    public function __construct() {
        parent::__construct();
         if (! $this->session->userdata ( 'user_logged_in' ) && ! $this->session->userdata ( 'user_logged_in' )) {
            redirect ( 'login', 'refresh' );
        }
        $this->load->vars ( array (
                'global' => 'Available to all views',
                'header' => 'common/header',
                'left' => 'common/left',
                'footer' => 'common/footer' 
        ) );

        $this->load->model('User_model');
        $this->load->model('Purchase_model');
    }

    public function index(){
        $data['purchase_list'] = $this->Purchase_model->purchase_list();
        $this->load->view('purchase_list',$data);
    }

    public function newpurchase(){
        $data['bill_id'] = !empty($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
        if (!empty($data['bill_id'])) {
            $bill_details = $this->Purchase_model->get_from_table('purchase_bill','*',array('bill_no' => $data['bill_id']));
            $data['bill_data'] = (array)$bill_details[0];
            $data['item_details'] = $this->Purchase_model->get_from_table('bill_item_detail','*',array('purchase_bill_id' => $data['bill_data']['purchase_bill_id']));
            $data['customer_details'] = $this->User_model->get_user_data($data['bill_data']['vendor_id']);
        } else {
            $data['bill_id'] = $this->purchaseId();
        }

        $where = array('contact_type' => 2,'status' => 1);
        $data['customer_list'] = $this->User_model->user_list_where($where);
        //$data['bill_no'] = $this->purchaseId();
        $this->load->view('purchase_create',$data);
    }

    public function purchaseId(){
        return rand(0,5000).strtotime(date('d-m-y H:i:s'));
    }

    public function generate_bill(){
        $form_data = $this->input->post('bill_basic');
        $sum_amounts = $this->input->post('items_tot');
        $item_data = $this->input->post('items');
        $userState = $this->input->post('userState');
        $status = $this->input->post('status');

        $data['bill_data'] = array(
                'bill_no'    => $form_data[1]['value'],
                'vendor_id'   => $form_data[0]['value'],
                'order_no'      => $form_data[2]['value'],
                'bill_date'  => date('Y-m-d',strtotime(str_replace('/', '-', $form_data[3]['value']))),
                'due_date'      => date('Y-m-d',strtotime(str_replace('/', '-', $form_data[4]['value']))),
                'total'         => $sum_amounts['final_total'],
                'sub_total'     => $sum_amounts['sub_total'],
                'cgst_total'    => $sum_amounts['cgst'],
                'sgst_total'    => $sum_amounts['sgst'],
                'igst_total'    => $sum_amounts['igst'],
                'status'        => $status,
                'date_added'    => date('Y-m-d')
            );
        $check_bill = $this->Purchase_model->get_from_table('purchase_bill','*',array('bill_no' => $form_data[1]['value']));
        if (count($check_bill) > 0) {
            $purchase_bill_id =  $check_bill[0]->purchase_bill_id;
            $this->Purchase_model->update_data('purchase_bill',$data['bill_data'],array('bill_no' => $form_data[1]['value'],'purchase_bill_id' => $purchase_bill_id));
        } else {
            $purchase_bill_id = $this->Purchase_model->insert_data('purchase_bill',$data['bill_data']);    
        }

        if (count($item_data) > 0) {
            foreach ($item_data as $key => $value) {
                $item_details[] = array(
                    'purchase_bill_id' => $purchase_bill_id,
                    'item' => $value['item_name'],
                    'qty' => $value['quantity'],
                    'uom' => $value['uom'],
                    'rate' => $value['unit_price'],
                    //'discount' => $value['discount'],
                    'amount' => $value['price'],
                    'cgst' => (($userState == 19) ? ((($value['quantity'] * $value['unit_price']) * 1.5) / 100) : 0),
                    'sgst' => (($userState == 19) ? ((($value['quantity'] * $value['unit_price']) * 1.5) / 100) : 0),
                    'igst' => (($userState != 19) ? ((($value['quantity'] * $value['unit_price']) * 3) / 100) : 0)
                );
            }

            // $data['customer_details'] = $this->User_model->get_user_data($form_data[0]['value']);
            // $data['item_details'] = $item_details;
            if (count($check_bill) > 0) {
                $purchase_bill_id =  $check_bill[0]->purchase_bill_id;
                $this->Purchase_model->delete_data('bill_item_detail',array('purchase_bill_id' => $purchase_bill_id));
            }
            $this->Purchase_model->insert_data_batch('bill_item_detail',$item_details);
        }

        echo $form_data[1]['value'];
    }
}
?>