<?php
$this->load->view ( $left );
$this->load->view ( $header );
?>
<div class="row wrapper border-bottom white-bg page-heading">
    <div class="col-sm-4">
        <h2>Bank List</h2>
    </div>
    <div class="col-sm-8">
        <div class="title-action">
            <a href="<?php echo site_url("bank/newbank");?>" class="btn btn-primary">
                <i class="fa fa-plus-square-o"></i>
                <span class="m-l-xs">Add Bank</span>
            </a>
        </div>
    </div>
</div>
<div class="wrapper wrapper-content">
    <div class="row text-center animated fadeInRightBig">
        <table class="table" id="myTable">
        	<thead>
        		<tr>
        			<th>Account Name</th>
        			<th>Code</th>
                    <th>Bank Name</th>
                    <th>Account Number</th>
                    <th>Routing No.</th>
                    <th>Primary</th>
                    <th>Credit</th>
                    <th>Debit</th>
        			<th>Action</th>
        		</tr>
        	</thead>
            <tbody>
                <?php if (count($bank_list) > 0) {
                    foreach ($bank_list as $key_bank => $value_bank) {?>
                        <tr>
                           <td><?php echo !empty($value_bank->account_name) ? $value_bank->account_name : '';?></td>
                           <td><?php echo !empty($value_bank->account_code) ? $value_bank->account_code : '';?></td>
                           <td><?php echo !empty($value_bank->bank_name) ? $value_bank->bank_name  : '';?></td>
                           <td><?php echo !empty($value_bank->account_number ) ? $value_bank->account_number : '';?></td>
                           <td><?php echo !empty($value_bank->routing_number ) ? $value_bank->routing_number : '';?></td>
                           <td><?php echo ($value_bank->is_primary == 0) ? 'Non-Primary' : 'Primary';?></td>
                           <td><?php echo !empty($value_bank->credit ) ? number_format((float)($value_bank->credit + $value_bank->credit_bank_charges), 2, '.', '') : '0.00';?></td>
                           <td><?php echo !empty($value_bank->debit ) ? number_format((float)$value_bank->debit, 2, '.', '') : '0.00';?></td>
                           <td><a href="<?php echo site_url('bank/newbank/'.$value_bank->account_id);?>"><button class="btn btn-info btn-xs"><i class="fa fa-edit"></i></button></a></td>
                        </tr>
                <?php }
                }?>
            </tbody>
        </table>
    </div>
</div>
<?php $this->load->view($footer); ?>
<script type="text/javascript">
	$(document).ready(function(){
        $('#myTable').DataTable();
	});
</script>