<?php
$this->load->view ( $left );
$this->load->view ( $header );
?>
<div class="row wrapper border-bottom white-bg page-heading">
    <div class="col-sm-4">
        <h2>Purchase Bill List</h2>
    </div>
    <div class="col-sm-8">
        <div class="title-action">
            <a href="<?php echo site_url("purchase/newpurchase");?>" class="btn btn-primary addNewUser">
                <i class="fa fa-plus-square-o"></i>
                <span class="m-l-xs">Create Invoice</span>
            </a>
        </div>
    </div>
</div>
<div class="wrapper wrapper-content">
    <div class="row text-center animated fadeInRightBig">
        <table class="table" id="myTable">
        	<thead>
        		<tr>
        			<th>Date</th>
        			<th>Invoice#</th>
                    <th>Order No.</th>
                    <th>Customer</th>
                    <th>Status</th>
                    <th>Due Date</th>
                    <th>Amount</th>
        			<th>Balance Due</th>
        		</tr>
        	</thead>
            <tbody>
                <?php 
                if (count($purchase_list) > 0) {
                    foreach ($purchase_list as $key_invoice => $value_invoice) {
                        if (strtotime($value_invoice->due_date) < strtotime(date('Y-m-d'))) {
                            if (($value_invoice->total - $value_invoice->payment) == 0) {
                                $status = "<span class='label label-success-light'>Paid</span>";
                            }else{
                                $status = "<span class='label label-danger-light'>Over Due</span>";
                            }
                        } else {
                            if (($value_invoice->total - $value_invoice->payment) == 0) {
                                $status = "<span class='label label-success-light'>Paid</span>";
                            }else{
                                $status = "<span class='label label-warning-light'>Due</span>";
                            }
                        }
                        ?>
                        <tr>
                           <td><?php echo !empty($value_invoice->bill_date) ? date('d/m/Y',strtotime(str_replace('-', '/', $value_invoice->bill_date))) : '';?></td>
                           <td><?php echo !empty($value_invoice->bill_no) ? $value_invoice->bill_no : '';?></td>
                           <td><?php echo !empty($value_invoice->order_no) ? $value_invoice->order_no  : '';?></td>
                           <td><?php echo !empty($value_invoice->name) ? $value_invoice->name : '';?></td>
                           <td><?php echo $status;?></td>
                           <td><?php echo !empty($value_invoice->due_date ) ? date('d/m/Y',strtotime(str_replace('-', '/', $value_invoice->due_date))) : '';?></td>
                           <td><?php echo !empty($value_invoice->total ) ? number_format((float)$value_invoice->total, 2, '.', '') : '';?></td>
                           <td><?php echo (($value_invoice->total - $value_invoice->payment) > 0) ? number_format((float)($value_invoice->total - $value_invoice->payment), 2, '.', '') : '0.00';?></td>
                        </tr>
                <?php }
                }?>
            </tbody>
        </table>
    </div>
</div>
<?php $this->load->view($footer); ?>
<script type="text/javascript">
	$(document).ready(function(){
        $('#myTable').DataTable();
	});
</script>